var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var DataStoreAbstract = require('./DataStoreAbstract');
var URLRequest = require('../../net/URLRequest');
var URLLoader = require('../../net/URLLoader');
var URLRequestMethod = require('../../net/URLRequestMethod');
var URLLoaderDataFormat = require('../../net/URLLoaderDataFormat');
var URLContentType = require('../../net/URLContentType');
var LoaderEvent = require('../../event/LoaderEvent');
/**
 * The JsonDataStore...
 *
 * @class JsonDataStore
 * @module StructureJS
 * @submodule model
 * @constructor
 * @param path {string}
 * @param jsonp {boolean}
 * @author Robert S. (www.codeBelt.com)
 */
var JsonDataStore = (function (_super) {
    __extends(JsonDataStore, _super);
    function JsonDataStore(path, jsonp) {
        if (jsonp === void 0) { jsonp = false; }
        _super.call(this, path);
        /**
         * TODO: YUIDoc_comment
         *
         * @property _urlLoader
         * @type {URLLoader}
         * @protected
         */
        this._urlLoader = null;
        /**
         * TODO: YUIDoc_comment
         *
         * @property _isJsonP
         * @type {boolean}
         * @default false
         * @protected
         */
        this._isJsonP = false;
        this._isJsonP = jsonp;
    }
    /**
     *
     * @method load
     * @public
     * @chainable
     */
    JsonDataStore.prototype.load = function () {
        var request = new URLRequest(this.src);
        request.method = URLRequestMethod.GET;
        request.contentType = URLContentType.JSON;
        if (this._isJsonP === true) {
            request.data = { format: 'json' };
        }
        this._urlLoader = new URLLoader();
        this._urlLoader.addEventListener(LoaderEvent.COMPLETE, this._onLoaderComplete, this);
        this._urlLoader.dataFormat = URLLoaderDataFormat.JSONP;
        this._urlLoader.load(request);
        return this;
    };
    /**
     * @overridden DataStoreAbstract._onLoaderComplete
     */
    JsonDataStore.prototype._onLoaderComplete = function (event) {
        this.data = this._urlLoader.data;
        this._urlLoader.removeEventListener(LoaderEvent.COMPLETE, this._onLoaderComplete, this);
        _super.prototype._onLoaderComplete.call(this);
    };
    return JsonDataStore;
})(DataStoreAbstract);
module.exports = JsonDataStore;
//# sourceMappingURL=JsonDataStore.js.map