var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var BaseRequest = require('./BaseRequest');
var URLContentType = require('../net/URLContentType');
var JsonRequest = (function (_super) {
    __extends(JsonRequest, _super);
    function JsonRequest(baseUrl) {
        _super.call(this, baseUrl);
        this.configureRequest();
    }
    /**
     * @overridden BaseRequest.parseData
     */
    JsonRequest.prototype.parseData = function () {
        _super.prototype.parseData.call(this);
        this.data = JSON.parse(this.data);
    };
    /**
     * @overridden BaseRequest.configureRequest
     */
    JsonRequest.prototype.configureRequest = function () {
        var urlRequest = _super.prototype.configureRequest.call(this);
        urlRequest.contentType = URLContentType.JSON;
        return urlRequest;
    };
    return JsonRequest;
})(BaseRequest);
module.exports = JsonRequest;
//# sourceMappingURL=JsonRequest.js.map