var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var EventDispatcher = require('../event/EventDispatcher');
var LoaderEvent = require('../event/LoaderEvent');
var URLRequest = require('../net/URLRequest');
var URLLoader = require('../net/URLLoader');
var URLRequestMethod = require('../net/URLRequestMethod');
var URLLoaderDataFormat = require('../net/URLLoaderDataFormat');
/**
 * The HtmlLoader...
 *
 * @class HtmlLoader
 * @module StructureJS
 * @submodule util
 * @constructor
 * @author Robert S. (www.codeBelt.com)
 */
var HtmlLoader = (function (_super) {
    __extends(HtmlLoader, _super);
    function HtmlLoader(path) {
        _super.call(this);
        this._urlLoader = null;
        this.complete = false;
        this.src = path;
        this._urlLoader = new URLLoader();
        this._urlLoader.addEventListener(LoaderEvent.COMPLETE, this.onLoaderComplete, this);
        this._urlLoader.dataFormat = URLLoaderDataFormat.HTML;
    }
    HtmlLoader.prototype.load = function () {
        if (this.complete) {
            return;
        }
        var request = new URLRequest(this.src);
        request.method = URLRequestMethod.GET;
        this._urlLoader.load(request);
    };
    HtmlLoader.prototype.onLoaderComplete = function (event) {
        this.complete = true;
        this.data = this._urlLoader.data;
        this.dispatchEvent(new LoaderEvent(LoaderEvent.COMPLETE));
        this._urlLoader.removeEventListener(LoaderEvent.COMPLETE, this.onLoaderComplete, this);
        this._urlLoader = null;
    };
    return HtmlLoader;
})(EventDispatcher);
module.exports = HtmlLoader;
//# sourceMappingURL=HtmlLoader.js.map